# --------------------------------------------------------------------------- #
#
#  hatena/utility.rb
#
#  Copyright (c) 2008, clown. All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#    - No names of its contributors may be used to endorse or promote
#      products derived from this software without specific prior written
#      permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#  Last-modified: Wed 20 Aug 2008 23:27:23 JST
#
# --------------------------------------------------------------------------- #

module Hatena
	require 'time'
	require 'digest/sha1'
	
	# ----------------------------------------------------------------------- #
	#  escape
	#
	#  API for getting Hatena Bookmark information needs to escape
	#  characters of "#".
	# ----------------------------------------------------------------------- #
	def escape(uri)
		return uri.gsub('#', '%23')
	end
	module_function :escape
	
	# ----------------------------------------------------------------------- #
	#  wsse
	# ----------------------------------------------------------------------- #
	def wsse(id, pass)
		created = Time.now.utc
		nonce = ""
		20.times { nonce << rand(256) }
		nonce_base64 = [nonce].pack('m').chomp
		created = created.iso8601
		digest = [Digest::SHA1.digest(nonce + created + pass)].pack('m').chomp
		
		result = sprintf(%Q<UsernameToken Username="%s", PasswordDigest="%s", Nonce="%s", Created"%s">,
			id, digest, nonce_base64, created)
		return result
	end
	module_function :wsse
end
